
(declaim (optimize (speed 3) (debug 0) (safety 0) (space 0) (compilation-speed 0))
	 (ftype (function (fixnum) fixnum) fibonacci)
	 (ftype (function (fixnum) fixnum) factorial)
)



(defun fibonacci (n)
"Computes the n-term of the Fibonacci's sequence."
(declare (type fixnum a aa s n))
(if (< n 2) 
    1 
    (do ( (a 1) (aa 1) (s 0))
	  ((= n 1) s)
	  (setq s (+ a aa))
	  (setq a aa)
	  (setq aa s)
	  (setq n (1- n))
    )
    
)
)

(defun factorial (n)
"Simply computes n! in an iterative way."
(declare (type fixnum f n))
(if (< n 3)
    n
    (do ( (f 2))
	((= n 2) f)
        (setq f (* f n))
        (setq n (1- n))
    )
))
    
;; Nota, el declare es inutil p.q de tota manera fem un ceoerce que força el tipus.
;; Misteriosament, aquest forçat si provoca una optimitzacio per part del compilador i no com passa si fem servir el declare :p
(defun h_integral (fun ia ib &key (nodes 1024))
"Calculates am integrals at interval [ia,ib] for the function fun using 'nodes' points."
(declare (type long-float a b x ac step)
	 (type fixnum nodes))
(let ( (a (coerce ia 'long-float)) (b (coerce ib 'long-float)) )
(do* ( (step (/ (- b a) nodes)) (ac 0.0L0) (x (+ a (/ step 2.0L0)))) 
    ( (> x b) (coerce (* ac (/ (- b a) (- nodes 2))) (type-of ia) ))
    (setq ac (+ ac (funcall fun x)))
    (setq x (+ x step))
)))


;; Ara la funcio que realment integra (h_integral es un borreguet per a aquesta)
(defun integrate (fun ia ib &key (tol 1e-6) (nodes 1024))
"Calculates the integral valueo of a function at interval [ia,ib] with a tolerance 'tol', starting with 'nodes' points."
(declare (type long-float a b s)
	 (type fixnum nodes)
	 (float ia ib)
)


(let ( (a (coerce ia 'long-float)) (b (coerce ib 'long-float)) (tl (coerce tol 'long-float)))
;; Versio interna mes rapida!!
(defun hi_integral (nodes)
(declare (type long-float a b x ac step)
	 (type fixnum nodes))
(do* ( (step (/ (- b a) nodes)) (ac 0.0L0) (x (+ a (/ step 2.0L0)))) 
    ( (> x b) (* ac (/ (- b a) (- nodes 2))))
    (setq ac (+ ac (funcall fun x)))
    (setq x (+ x step))
))
;;-----------------------------
(do ( (as -1.0L0) (s 0.0L0) )
    ( (< (abs (- as s)) (* tl s)) (typecase ia
				    (long-float s)
				    (double-float (coerce s 'double-float))
				    (t (coerce s 'float))
				  ))
  (setq as s)
  (setq nodes (* nodes 2))
  (setq s (/(+ s (* 2.0L0 (hi_integral nodes))) 3.0L0 ))
)))







